using System.ComponentModel;
using System.Data;

namespace WinFormsApp1
{
    public partial class Form1 : Form
    {
        MyTitle title = new MyTitle();

        public Form1()
        {
            InitializeComponent();
        }

        int _mode = 4;
        DataTable _dt = new DataTable();
        DataSet _ds = new DataSet();

        private void Form1_Load(object sender, EventArgs e)
        {
            var myTitleBinding = new BindingSource();
            myTitleBinding.DataSource = title;

            textBox1.DataBindings.Add(new Binding("Text", myTitleBinding, "Title", true, DataSourceUpdateMode.OnPropertyChanged));

            if (_mode == 0)
            {
                this.dataGridView1.Columns.Add(new DataGridViewColumn(new DataGridViewTextBoxCell()) { HeaderText = "idx" });
                this.dataGridView1.Columns.Add(new DataGridViewColumn(new DataGridViewTextBoxCell()) { HeaderText = "value" });

                this.dataGridView1.Rows.Add(1, "test1");
                this.dataGridView1.Rows.Add(2, "test2");
            }
            else if (_mode == 1)
            {
                MyData m1 = new MyData { Age = 30, Name = "Kevin" };
                MyData m2 = new MyData { Age = 31, Name = "Winnie" };

                BindingList<MyData> data = new BindingList<MyData>() { m1, m2 };
                // List<MyData> data = new List<MyData> { m1, m2 };
                this.dataGridView1.DataSource = data;
            }
            else if (_mode == 2)
            {
                MyData m1 = new MyData { Age = 30, Name = "Kevin" };
                MyData m2 = new MyData { Age = 31, Name = "Winnie" };

                BindingList<MyData> data = new BindingList<MyData>() { m1, m2 };

                var dataBindingSource = new BindingSource();
                dataBindingSource.DataSource = data;

                this.dataGridView1.DataSource = dataBindingSource;
            }
            else if (_mode == 3)
            {
                _dt.Columns.Add("idx");
                _dt.Columns.Add("value");
                _dt.Rows.Add(1, "test1");
                _dt.Rows.Add(2, "test2");

                this.dataGridView1.DataSource = _dt;
            }
            else if (_mode == 4)
            {
                DataTable dt1 = new DataTable("List");
                dt1.Columns.Add("idx");
                dt1.Columns.Add("value");
                dt1.Rows.Add(1, "test1");
                dt1.Rows.Add(2, "test2");

                DataTable dt2 = new DataTable("Person");
                dt2.Columns.Add("age");
                dt2.Columns.Add("name");
                dt2.Rows.Add(30, "Kevin");
                dt2.Rows.Add(31, "Winnie");

                _ds = new DataSet();
                _ds.Tables.Add(dt1);
                _ds.Tables.Add(dt2);

                var dataBindingSource = new BindingSource();
                dataBindingSource.DataSource = _ds;
                // dataBindingSource.DataMember = "List";
                dataBindingSource.DataMember = "Person";

                // this.dataGridView1.DataMember = "Person";
                this.dataGridView1.DataSource = dataBindingSource;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.title.Title = DateTime.Now.ToString();

            if (_mode == 0)
            {
                this.dataGridView1.Rows.Add("3", "test3");
                this.dataGridView1.Rows.RemoveAt(0);
            }
            else if (_mode == 1)
            {
                BindingList<MyData>? data = this.dataGridView1.DataSource as BindingList<MyData>;
                data?.Add(new MyData { Age = 32, Name = "Cooper" });
            }
            else if (_mode == 2)
            {
                BindingSource? src = this.dataGridView1.DataSource as BindingSource;
                if (src == null)
                {
                    return;
                }

                BindingList<MyData>? data = src.DataSource as BindingList<MyData>;
                data?.Add(new MyData { Age = 32, Name = "Cooper" });
            }
            else if (_mode == 3)
            {
                _dt.Rows.Add(3, "test3");
            }
            else if (_mode == 4)
            {
                _ds.Tables[0].Rows.Add(3, "test3");
                _ds.Tables[1].Rows.Add(32, "Cooper");
            }
        }
    }
}